SystemOrganization addCategory: #TADP1!

TestCase subclass: #TestAptaParaJugar
	instanceVariableNames: 'computadora'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP1'!

!TestAptaParaJugar methodsFor: 'accessing' stamp: 'Braian 4/13/2013 15:40'!
computadora
	^ computadora! !

!TestAptaParaJugar methodsFor: 'accessing' stamp: 'Braian 4/13/2013 15:40'!
computadora: anObject
	computadora := anObject! !

!TestAptaParaJugar methodsFor: 'accessing' stamp: 'Braian 4/13/2013 15:50'!
setUp
	computadora := Computadora new.! !

!TestAptaParaJugar methodsFor: 'accessing' stamp: 'Braian 4/13/2013 16:25'!
testAptitudConPlacaComun

	self computadora placaDeVideo: (Comun new).
	
	self computadora placaDeVideo resolucion: (1024*768). 
	
	self computadora placaDeVideo consumoPromedio: 150.
	
	self computadora aptaParaVideoJuegos.! !

!TestAptaParaJugar methodsFor: 'accessing' stamp: 'Braian 4/13/2013 16:10'!
testAptitudConPlacaGpu
	
	self computadora placaDeVideo: (Gpu new).
	
	self computadora aptaParaVideoJuegos.
	
	! !

!TestAptaParaJugar methodsFor: 'accessing' stamp: 'Braian 4/13/2013 17:30'!
testAptitudConPlacaOnBoard

	self computadora placaDeVideo: (OnBoard new).
	
	self computadora aptaParaVideoJuegos.! !

TestCase subclass: #TestConsumoComputadora
	instanceVariableNames: 'computadora'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP1'!

!TestConsumoComputadora methodsFor: 'accessing' stamp: 'Brimba 4/7/2013 01:42'!
computadora
	^ computadora! !

!TestConsumoComputadora methodsFor: 'accessing' stamp: 'Brimba 4/7/2013 01:42'!
computadora: anObject
	computadora := anObject! !

!TestConsumoComputadora methodsFor: 'as yet unclassified' stamp: 'Brimba 4/7/2013 01:33'!
setUp 
	computadora := Computadora new.! !

!TestConsumoComputadora methodsFor: 'as yet unclassified' stamp: 'Brimba 4/7/2013 01:53'!
testConsumoComputadoraConDiscoMagnetico

	self computadora agregarComponente: (DiscoMagnetico new: 1000). 
	
	self assert: self computadora consumoTotal = 6.! !

!TestConsumoComputadora methodsFor: 'as yet unclassified' stamp: 'Brimba 4/7/2013 01:53'!
testConsumoComputadoraConDiscoSolido
	
	self computadora componentes: Bag new.
	
	self computadora agregarComponente: (DiscoSolido new: 300). 
	
	self assert: self computadora consumoTotal = 300.! !

!TestConsumoComputadora methodsFor: 'as yet unclassified' stamp: 'Brimba 4/7/2013 03:09'!
testConsumoComputadoraConDiscoYPlaca

	self computadora componentes: Bag new.
	
	self computadora 
				placaDeVideo: (Gpu new: 800 y: 600 y: (Pantalla new: 1254400) y: 14);
			     	agregarComponente: (DiscoMagnetico new: 1000).
				
	self assert: self computadora consumoTotal = 17.8.! !

!TestConsumoComputadora methodsFor: 'as yet unclassified' stamp: 'Brimba 4/7/2013 03:10'!
testConsumoComputadoraPlacasConCoolers

	self computadora componentes: Bag new.
	
	self computadora placaDeVideo: (Gpu new: 800 y: 600 y: (Pantalla new: 1254400) y: 14).
	
	self assert: self computadora consumoTotal = 11.8.! !

Object subclass: #Componente
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP1'!

!Componente methodsFor: 'as yet unclassified' stamp: 'Brimbo 4/6/2013 16:25'!
consumo
	self subclassResponsibility ! !

Componente subclass: #DiscoMagnetico
	instanceVariableNames: 'rpm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP1'!

!DiscoMagnetico class methodsFor: 'as yet unclassified' stamp: 'Brimbo 4/6/2013 20:24'!
new: revoluciones
	|instancia|
	instancia := super new.
	instancia rpm: revoluciones.
	^instancia.! !

!DiscoMagnetico methodsFor: 'as yet unclassified' stamp: 'Brimbo 4/6/2013 16:33'!
consumo
	^self rpm * 60 / 10000! !

!DiscoMagnetico methodsFor: 'accessing' stamp: 'Brimbo 4/6/2013 18:04'!
rpm
	^ rpm! !

!DiscoMagnetico methodsFor: 'accessing' stamp: 'Brimbo 4/6/2013 18:04'!
rpm: anObject
	rpm := anObject! !

Componente subclass: #DiscoSolido
	instanceVariableNames: 'consumoEspecifico'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP1'!

!DiscoSolido class methodsFor: 'as yet unclassified' stamp: 'Brimbo 4/6/2013 20:24'!
new: unConsumo 
	|instancia|
	instancia := super new.
	instancia consumoEspecifico: unConsumo.
	^instancia.! !

!DiscoSolido methodsFor: 'as yet unclassified' stamp: 'Brimbo 4/6/2013 17:26'!
consumo 
	^self consumoEspecifico! !

!DiscoSolido methodsFor: 'accessing' stamp: 'Brimbo 4/6/2013 18:05'!
consumoEspecifico
	^ consumoEspecifico! !

!DiscoSolido methodsFor: 'accessing' stamp: 'Brimbo 4/6/2013 18:05'!
consumoEspecifico: anObject
	consumoEspecifico := anObject! !

Componente subclass: #PlacaDeVideo
	instanceVariableNames: 'cantidadDeCoolers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP1'!

PlacaDeVideo subclass: #Comun
	instanceVariableNames: 'consumoPromedio resolucion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP1'!

!Comun class methodsFor: 'as yet unclassified' stamp: 'Brimbo 4/6/2013 20:22'!
new: unConsumo y: cantCoolers 
	|instancia|
	instancia := super new: cantCoolers.
	instancia consumoPromedio: unConsumo.
	^instancia.! !

!Comun methodsFor: 'accessing' stamp: 'Brimbo 4/6/2013 17:28'!
consumoPromedio: anObject
	consumoPromedio := anObject! !

!Comun methodsFor: 'as yet unclassified' stamp: 'Brimba 4/7/2013 03:28'!
consumoPropio 
	^consumoPromedio! !

!Comun methodsFor: 'accessing' stamp: 'Braian 4/13/2013 17:21'!
criterioDeAptitud
	^(self resolucion ln / self consumoPropio) <= 4.
	! !

!Comun methodsFor: 'accessing' stamp: 'Braian 4/13/2013 16:21'!
resolucion
	^ resolucion! !

!Comun methodsFor: 'accessing' stamp: 'Braian 4/13/2013 16:21'!
resolucion: anObject
	resolucion := anObject! !

PlacaDeVideo subclass: #Gpu
	instanceVariableNames: 'anchoMax largoMax pantalla'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP1'!

!Gpu class methodsFor: 'as yet unclassified' stamp: 'Brimbo 4/6/2013 20:21'!
new:  unAnchoMax y: unLargoMax y: unaPantalla y: cantCoolers
	|instancia|
	instancia := super new: cantCoolers.
	instancia anchoMax:  unAnchoMax.
	instancia largoMax: unLargoMax.
	instancia pantalla: unaPantalla.
	^instancia.	! !

!Gpu methodsFor: 'accessing' stamp: 'Brimbo 4/6/2013 17:28'!
anchoMax
	^ anchoMax! !

!Gpu methodsFor: 'accessing' stamp: 'Brimbo 4/6/2013 17:28'!
anchoMax: anObject
	anchoMax := anObject! !

!Gpu methodsFor: 'as yet unclassified' stamp: 'Brimbo 4/6/2013 16:48'!
consumoPropio 
	^(self resolucion) * (1/100000)! !

!Gpu methodsFor: 'as yet unclassified' stamp: 'Brimba 4/7/2013 03:22'!
criterioDeAptitud
	^true.! !

!Gpu methodsFor: 'accessing' stamp: 'Brimbo 4/6/2013 17:29'!
largoMax
	^ largoMax! !

!Gpu methodsFor: 'accessing' stamp: 'Brimbo 4/6/2013 17:29'!
largoMax: anObject
	largoMax := anObject! !

!Gpu methodsFor: 'accessing' stamp: 'Brimbo 4/6/2013 17:29'!
pantalla
	^ pantalla! !

!Gpu methodsFor: 'accessing' stamp: 'Brimbo 4/6/2013 17:29'!
pantalla: anObject
	pantalla := anObject! !

!Gpu methodsFor: 'as yet unclassified' stamp: 'Brimbo 4/6/2013 16:53'!
resolucion 
	^self resolucionMaxima min: self pantalla resolucion! !

!Gpu methodsFor: 'as yet unclassified' stamp: 'Brimbo 4/6/2013 16:47'!
resolucionMaxima
	^self anchoMax * self largoMax! !

PlacaDeVideo subclass: #OnBoard
	instanceVariableNames: 'consumoEspecifico'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP1'!

!OnBoard methodsFor: 'accessing' stamp: 'Edu 4/13/2013 19:45'!
consumoEspecifico: anObject
	consumoEspecifico := anObject! !

!OnBoard methodsFor: 'as yet unclassified' stamp: 'Edu 4/13/2013 19:44'!
consumoPropio 
	^consumoEspecifico! !

!OnBoard methodsFor: 'as yet unclassified' stamp: 'Brimba 4/7/2013 03:23'!
criterioDeAptitud 
	^false.! !

!PlacaDeVideo class methodsFor: 'as yet unclassified' stamp: 'Brimbo 4/6/2013 20:23'!
new: cantCoolers
	|instancia|
	instancia := super new.
	instancia cantidadDeCoolers: cantCoolers.
	^instancia.! !

!PlacaDeVideo methodsFor: 'accessing' stamp: 'Brimbo 4/6/2013 17:27'!
cantidadDeCoolers
	^ cantidadDeCoolers! !

!PlacaDeVideo methodsFor: 'accessing' stamp: 'Brimbo 4/6/2013 17:27'!
cantidadDeCoolers: anObject
	cantidadDeCoolers := anObject! !

!PlacaDeVideo methodsFor: 'as yet unclassified' stamp: 'Brimbo 4/6/2013 16:42'!
consumo
	^self consumoPropio + self consumoCoolers! !

!PlacaDeVideo methodsFor: 'as yet unclassified' stamp: 'Brimba 4/7/2013 00:42'!
consumoCoolers 
	^cantidadDeCoolers * 0.5! !

!PlacaDeVideo methodsFor: 'accessing' stamp: 'Edu 4/13/2013 19:07'!
consumoPropio
	self subclassResponsibility ! !

!PlacaDeVideo methodsFor: 'as yet unclassified' stamp: 'Brimba 4/7/2013 03:20'!
criterioDeAptitud 
	self subclassResponsibility.! !

Object subclass: #Computadora
	instanceVariableNames: 'componentes placaDeVideo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP1'!

!Computadora class methodsFor: 'as yet unclassified' stamp: 'Brimbo 4/6/2013 20:23'!
new
	 |unaInstancia|
	unaInstancia := super new.
	unaInstancia componentes: Bag new.
	^unaInstancia.! !

!Computadora methodsFor: 'as yet unclassified' stamp: 'Brimbo 4/6/2013 17:30'!
agregarComponente: unComponente 
	componentes add: unComponente! !

!Computadora methodsFor: 'accessing' stamp: 'Brimba 4/7/2013 03:19'!
aptaParaVideoJuegos
	^self placaDeVideo criterioDeAptitud! !

!Computadora methodsFor: 'accessing' stamp: 'Brimbo 4/6/2013 20:27'!
componentes
	^ componentes! !

!Computadora methodsFor: 'accessing' stamp: 'Brimbo 4/6/2013 20:27'!
componentes: anObject
	componentes := anObject! !

!Computadora methodsFor: 'as yet unclassified' stamp: 'Brimbo 4/6/2013 17:23'!
consumoTotal
	^componentes sum:[:unComponente | unComponente consumo]! !

!Computadora methodsFor: 'accessing' stamp: 'Brimba 4/7/2013 03:07'!
placaDeVideo
	^placaDeVideo.! !

!Computadora methodsFor: 'accessing' stamp: 'Brimba 4/7/2013 03:08'!
placaDeVideo: unaPlacaDeVideo
	placaDeVideo := unaPlacaDeVideo.
	componentes add: unaPlacaDeVideo.! !
